package lv.tsi.oodb.core;

import org.odmg.*;

/**
 * Named wrapper.
 *
 * @author  Alexey Vasilyev
 * @version 0.0.5 4 December 2000
 */
public class NamedWrapper implements java.io.Serializable {

    public final transient int DELETE = 0;
    public final transient int INSERT = 1;
    public final transient int NORMAL = 2;

    private MetaObject object;
    private String     name;

    public NamedWrapper(MetaObject object, String name) {
        this.object = object;
        this.name   = name;
    }

    public final MetaObject getObject() { return object; }
    public final String getName()       { return name;   }
    public final int    hashCode()      { return name.hashCode(); }
    public final OID getOID()           { return object.getOID(); }
    public final String toString()      { return name;   }

}
