package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Address Class. Represents Address business object of our schema
 * 
 * @author Alex Gulaev
 * @versio 0.0.4 03 December 2000
 */
public class Address extends MetaObject {
        
    private String classID;
    private String street;
    private String street2="";
    private String city;
    private String state;
    private String country;
    private String zip;
    private String www="";
    private String receiverNotice="";
    private String description="";
    private String email="";
    private String phones="";
    private String faxes="";
    

    //***** Relations *******

     private Organization organization;
     private Delivery delivery;
     private Manufacturer mnf;
     
    //************************

    public Address() {}
    
    public void init( String classID, String street, String street2,
                    String city, String state, String country, String zip) {
        
     this.classID = classID;
     this.street  = street;
     this.street2 = street2;
     this.city    = city;
     this.state   = state;
     this.country = country;
     this.zip     = zip;
     
    }

    
    public void init( String classID, String street, String street2,
                    String city, String state, String country,
                    String zip, String www, String receiverNotice,
                    String description, String email, String phones,
                    String faxes) {
        
     this.classID = classID;
     this.street  = street;
     this.street2 = street2;
     this.city    = city;
     this.state   = state;
     this.country = country;
     this.zip     = zip;
     this.www     = www;
     this.receiverNotice = receiverNotice;
     this.description    = description;
     this.email   = email;
     this.phones  = phones;
     this.faxes   = faxes; 

    }
  
    public void setClassID(String classID) {
     this.classID = classID;
    }
     
    public void setStreet(String street) {
     this.street  = street;
    }
    
    public void setStreet2(String street2) {
     this.street2 = street2;
    }
     
    public void setCity(String city) { 
     this.city    = city;
    }

    public void setState(String state) {
     this.state   = state;
    } 
     
    public void setCountry(String country) {
     this.country = country;
    } 

    public void setZip(String zip) { 
     this.zip     = zip;
    } 
     
    public void setWWW(String www) {
     this.www     = www;
    }
     
    public void setReceivrNotice(String receiverNotice) {
     this.receiverNotice = receiverNotice;
    }

    public void setDescription(String description) { 
     this.description    = description;
    } 
     
    public void setEmail(String email) {
     this.email   = email;
    } 
     
    public void setPhones(String phones) {
     this.phones  = phones;
    } 
     
    public void setFaxes(String faxes) {
     this.faxes   = faxes; 
    }
    

    
    
    public String getClassID() {
     return classID;
    }
     
    public String getStreet() {
     return street;
    }
    
    public String getStreet2() {
     return street2;
    }
     
    public String getCity() { 
     return city;
    }

    public String getState() {
     return state;
    } 
     
    public String getCountry() {
     return country;
    } 

    public String getZip() { 
     return zip;
    } 
     
    public String getWWW() {
     return www;
    }
     
    public String getReceivrNotice() {
     return receiverNotice;
    }

    public String getDescription() { 
     return description;
    } 
     
    public String getEmail() {
     return email;
    } 
     
    public String getPhones() {
     return phones;
    } 
     
    public String getFaxes() {
     return faxes; 
    }
    

    
    

    public void linkToOrganization(Organization org) {
       organization = org;
    }
    
    
    public Organization getOrganization() {
       return organization;
    }

    public void linkToDelivery(Delivery dlv) {
       delivery = dlv;
    }
    
    
    public Delivery getDelivery() {
       return delivery;
    }


    public void linkToManufacturer(Manufacturer m) {
       mnf = m;
    }
    
    
    public Manufacturer getManufacturer() {
       return mnf;
    }

    
    
    

    

    public String toString() {
        return "Address id: " + this.getOID().toString();
    }

}
