package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Category Class. Represents Category business object of our scheme
 * May contain some Products.
 *
 * @author Alex Gulaev
 * @versio 0.0.4 03 December 2000
 */
public class Category extends MetaObject {
     
    
    private String classID;
    private String name;
    private String identifier;
    private String howToUse;
    private String description;
    
    //***** Relations *******
    
    private SetOfObject products = new SetOfObject();
      
    //************************

    public Category(){}

    public void init( String classID, String name, String identifier) {

        this.classID       = classID;
        this.name          = name;
        this.identifier    = identifier;
        this.howToUse      = "";
        init(classID, name, identifier, "");
        
    }


    public void init( String classID, String name, String identifier, String howToUse) {

        this.classID       = classID;
        this.name          = name;
        this.identifier    = identifier;
        this.howToUse      = howToUse;
    
    }

     public void init( String classID, String name, String identifier, String howToUse, String description) {

        this.classID       = classID;
        this.name          = name;
        this.identifier    = identifier;
        this.howToUse      = howToUse;
        this.description   = description;
        

    }

    
    
    public void setClassID (String classID){
        this.classID       = classID;
    }

    public void setName (String name){
        this.name          = name;
    }

    public void setIdentifier (String identifier){ 
        this.identifier    = identifier;
    }
        
    public void setHowToUse (String howToUse){
        this.howToUse      = howToUse;
    }

    public void setDescription (String description){
        this.description      = description;
    }
        

    public String getClassID (){
        return classID;
    }

    public String getName (){
        return name;
    }

    public String getIdentifier (){ 
        return identifier;
    }
        
    public String getHowToUse (){
        return howToUse;
    }

    public String getDescription (){
        return description;
    }

    
         

    public void addProduct( Product prod ) {
        products.add(prod);
    }
    
    public SetOfObject getProducts() {
        return products;
    }

    
    
    public String toString() {
        return "Category id: " + this.getOID().toString() +", Name: " + name;
    }

}
