package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Delivery Class. Represents Delivery business object of our scheme
 *
 * @author Alex Gulaev
 * @versio 0.0.4 03 December 2000
 */
public class Delivery extends MetaObject {
      
   
     private String name;
     private String description;
     private Date updDate;
     private String trackingUrl;
    

    //***** Relations *******

    private SubOrder suborder;
    private SetOfObject trucks = new SetOfObject();
    private Address address;
    
    //************************


    public Delivery(){};
    

    public void init(String name, Date upd) {

        init( name, "", upd, ""); 
    }
    
    
    public void init( String name, Date upd, String url) {
        
        init( name, "", upd, url); 
    }


    public void init( String name, String desc, Date upd, String url) {

        this.name          = name;
        this.description   = desc;
        this.updDate       = upd;
        this.trackingUrl   = url;
    }


    public void setName(String name) {  
        this.name          = name;
    }    

    public void setDescription(String desc) {  
        this.description   = desc;
    }    

    public void setUpdDate(Date upd) {  
        this.updDate       = upd;
    }    

    public void setTrackingUrl(String url) {  
        this.trackingUrl   = url;
    }

    
    public String getName() {  
        return name;
    }    

    public String getDescription() {  
        return description;
    }    

    public Date getUpdDate() {  
        return updDate;
    }    

    public String getTrackingUrl() {  
        return trackingUrl;
    }

    
        
    public void linkToSubOrder(SubOrder sb) {
       suborder = sb;
    }

    public void linkToAddress(Address adr) {
       address = adr;
    }

    
    public SubOrder getSubOrder() {
       return suborder;
    }

    public void addTruck (Truck trk){
       trucks.add(trk);
    }
    
    public SetOfObject getTrucks (){
       return trucks;
    }
    

    
    public String toString() {
        return "Delivery id: " + this.getOID().toString() +", Name: " + name;
    }

}
