package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * ItemDeatail Class. Represents item detail business object of our scheme
 *
 * @author Alex Gulaev
 * @version 0.0.4 03 December 2000
 */
public class ItemDetail extends MetaObject {

     
    private int qty;
    private Date createDate;
    private String description="";
    private boolean undone = true;
 
    
    //***** Relations *******
        
    private Status status;
    private Item item;
    private User user; 
    
    //************************


    public ItemDetail() {}
    

    
    public void init(int qty) {

        this.qty          = qty;
        this.createDate   = new Date();
      
    }
    
    public void init(int qty, Date createDate ) {

        this.qty          = qty;
        this.createDate   = createDate;
      
    }
    
    public void init(int qty, Date createDate, boolean undone ) {
        
        this.qty          = qty;
        this.createDate   = createDate;
        this.undone       = undone;

    }


    public void init(int qty, Date createDate, String desc, boolean undone ) {
        
        this.qty          = qty;
        this.createDate   = createDate;
        this.description  = desc;
        this.undone       = undone;

    }

        
    public void linkToStatus( Status stat ) {
        status = stat;
    }

    public void linkToItem( Item itm ) {
        item = itm;
    }

    public void linkToUser( User usr ) {
        user = usr;
    }



    public Status getStatus() {
        return status;
    }

    public Item getItem() {
        return item;
    }

    public User getUser() {
        return user;
    }



    public String toString() {
        return "ItemDetail id: " + this.getOID().toString();
    }

}
