package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Order Class. Represents order business object of our scheme. Hold some SubOrders.
 *
 * @author Alex Gulaev
 * @versio 0.0.4 02 December 2000
 */
public class Order extends MetaObject {
            
    String number;
    String type;
    Date createDate;
    Date updDate;
    
    //***** Relations *******

    private SetOfObject subOrders = new SetOfObject();
    private Status status;
    private SetOfObject users = new SetOfObject();

    //************************

     public Order() {}
    
     public void init(String number, String type, Date createDate, Date updDate ) {
      
       this.number      = number;
       this.type        = type;
       this.createDate  = createDate;
       this.updDate     = updDate; 
   
     }
    
     public void init(String number, String type ) {
      
       this.number      = number;
       this.type        = type;
       this.createDate  = new Date();
       this.updDate     = new Date(); 
   
     }

     public void setNumber(String number) {
       this.number      = number;
     }   

     public void setType(String type) {
       this.type        = type;
     }
       
     public void setUpdDate(Date updDate) {
       this.updDate     = updDate; 
     }   
    
    
     public String getNumber() {
       return number;
     }

     public String getType(){
       return type;
     }
     
     public Date getCreateDate(){
       return createDate;
     }
     
     public Date getUpdDate(){
       return updDate;
     }

     
     
    
    public void addSubOrder( SubOrder sb ) {
            subOrders.add( sb );
    }

    // Add users to Order (max =2, One buyer & One Supplier)
    public void addUser(User usr) {
        users.add(usr);
    }
       
    public void linkToStatus( Status stat ) {
        status = stat;
    }

    
    
    public SetOfObject getUsers() {
        return users;
    }

    public Status getStatus() {
        return status;
    }

    public SetOfObject getSubOrders() {
        return subOrders;
    }



    
    
    

    public String toString() {
        return "Order id: " + this.getOID().toString() +", Number: " + number;
    }

}
