package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Address Class. Represents Organization business object of our schema
 * 
 * @author Alex Gulaev
 * @versio 0.0.1 13 November 2000
 */
public class Organization extends MetaObject {
        
    private String name;
    private String businessType;
    private String classID;
    private boolean valid;
    private Date dateReg;
   

    //***** Relations *******

     private Address address;
     private SetOfObject employees = new SetOfObject();
    
    //************************

   public Organization() {}
    
    public void init(String name, String businessType, String classID){
        

      init(name, businessType, classID, true, new Date());
        
    }
  

    public void init(String name, String businessType, String classID,
                              boolean valid, Date dateReg){
        
      this.name         = name;
      this.businessType = businessType;
      this.classID      = classID;
      this.valid        = valid;
      this.dateReg      = dateReg;
        
    }
  
    
    public void setName(String name) {
      this.name = name;
    }
    
    public void setBusinessType(String businessType) {
      this.businessType = businessType;
    }

    public void setClassID(String classID) {
      this.classID      = classID;
    }  

    public void setValid(boolean valid) {
      this.valid        = valid;
    }  

    public void setDateReg(Date dateReg) {
      this.dateReg      = dateReg;
    }  

     

    public String getName() {
      return name;
    }
    
    public String getBusinessType() {
      return businessType;
    }

    public String getClassID() {
      return classID;
    }  

    public boolean isValid() {
      return valid;
    }  

    public Date getDateReg() {
      return dateReg;
    }  

    
   
    

    public void linkToAddress( Address adr ) {
        address = adr;
    }

    public void addEmployee( User empl ) {
        employees.add(empl);
    }


    public SetOfObject getEmployees() {
        return employees;
    }

    public Address getAddress() {
        return address;
    }


    

    public String toString() {
        return "SubOrder Location id: " + this.getOID().toString();
    }
    

}
