package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Product Class. Represents Product business object of our scheme
 *
 * @author Alex Gulaev
 * @versio 0.0.1 11 November 2000
 */
public class Product extends MetaObject {
       
    private String class_id;
    private String upc;
    private String model;
    private float map_price;
    private float width;
    private float length;
    private float height;
    private float weight;
    private float length_package;
    private float height_package;
    private float weight_package;
    private Date updDate;

    
    //***** Relations *******
      
    private SetOfObject categories = new SetOfObject();
    private Manufacturer manufacturer;
    private User supplier;
    private Item item;
     
    //************************

       
    public Product() {
       
    }

    
    public void init(String class_id, String upc, String model,
                     float map_price, float width, float length,
                     float height, float weight, float length_package,
                     float height_package, float weight_package, Date updDate){

      this.class_id       = class_id;
      this.upc            = upc;
      this.model          = model;
      this.map_price      = map_price;
      this.width          = width;
      this.length         = length;
      this.height         = height;
      this.weight         = weight;
      this.length_package = length_package;
      this.height_package = height_package;
      this.weight_package = weight_package;
      this.updDate        = updDate; 

    }

   public void init(String class_id, String upc, String model, float map_price, float width, float length, float height, float weight, float length_package, float height_package, float weight_package){


      init(class_id, upc, model, map_price, width, length,
                     height, weight, length_package,
                     height_package, weight_package, new Date());



    }
 

    public void setClass_id (String class_id){
      this.class_id       = class_id;
    }

    public void setUpc (String upc){
      this.upc            = upc;
    }  

    public void setModel (String model){
      this.model          = model;
    }

    public void setMap_price (float map_price){
      this.map_price      = map_price;
    }

    public void setWidth (float width){
      this.width          = width;
    }
    
    public void setLength (float length){
      this.length         = length;
    }
    
    public void setHeight (float height){
      this.height         = height;
    }  
      
    public void setWeight (float weight){ 
      this.weight         = weight;
    }
    
    public void setLength_package (float length_package){
      this.length_package = length_package;
    }
      
    public void setHeight_package (float height_package){
      this.height_package = height_package;
    }
      
    public void setWeight_package (float weight_package){
      this.weight_package = weight_package;
    }  
      
    public void setUpdDate (Date updDate){
      this.updDate        = updDate;
    }



    public String getClass_id (){
      return class_id;
    }

    public String getUpc (){
      return upc;
    }

    public String setModel (){
      return model;
    }

    public float getMap_price (){
      return map_price;
    }

    public float getWidth (){
      return width;
    }

    public float getLength (){
      return length;
    }

    public float getHeight (){
      return height;
    }

    public float getWeight (){
      return weight;
    }

    public float getLength_package (){
      return length_package;
    }

    public float getHeight_package (){
      return height_package;
    }

    public float getWeight_package (){
      return weight_package;
    }

    public Date getUpdDate (){
      return updDate;
    }
 

    
    
    
    public void addCategory( Category ctg ) {
        categories.add( ctg );
    }

    public void linkToManufacturer( Manufacturer mnft ) {
        manufacturer = mnft;
    }

    public void linkToSupplier( User supp ) {
        supplier = supp;
    }

    public void linkToItem( Item itm ) {
        item = itm;
    }


    public SetOfObject getCategory() {
        return categories;
    }

    public Manufacturer getManufacturer() {
        return manufacturer;
    }

    public User getSupplier() {
        return supplier;
    }

    public Item getItem() {
        return item;
    }
   
    
    
    
    public String toString() {
        return "Product id: " + this.getOID().toString();
    }

}
