package lv.tsi.oodb.db.orders;

import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.MetaObject;
import java.util.*;

/**
 * Truck Class. Represents Truck business object of our scheme
 *
 * @author Alex Gulaev
 * @versio 0.0.4 03 December 2000
 */
public class Truck extends MetaObject {
      
    
    private String truckNumber;
    // private String shipperName;
    private Date dlvDateFact;
    private Date createDate;
    private String truckNotes;
    

    //***** Relations *******

    private Delivery delivery;
    
    //************************
    public Truck(){}

    
    public void init( String truckNumber, Date dlvFact) {


        init( truckNumber, dlvFact, new Date() );
        
    }

    public void init( String truckNumber, Date dlvFact, Date create ) {

        init( truckNumber, dlvFact, create, "");
        
    }

    
    public void init( String truckNumber, Date dlvFact, Date create, String truckNotes ) {

        this.truckNumber   = truckNumber;
        this.dlvDateFact   = dlvFact;
        this.createDate    = create;
        this.truckNotes    = truckNotes;
     
    }


    public void setTruckNumber (String truckNumber) {
        this.truckNumber   = truckNumber;
    }

    public void setDlvDateFact (Date dlvDateFact) {
        this.dlvDateFact   = dlvDateFact;
    }

    public void setCreateDate (Date create) {
        this.createDate    = create;
    }
        
    public void setTruckNotes (String truckNotes) {
        this.truckNotes    = truckNotes;
    } 
    

    
    public String getTruckNumber () {
        return truckNumber;
    }

    public Date getDlvDateFact () {
        return dlvDateFact;
    }

    public Date getCreateDate () {
        return createDate;
    }
        
    public String getTruckNotes () {
        return truckNotes;
    } 


        

    public void linkToDelivery( Delivery dlv ) {
      delivery = dlv; 
    }

    public Delivery getDelivery() {
      return delivery; 
    }
   

    public String toString() {
        return "Truck id: " + this.getOID().toString() +", Number: " + truckNumber;
    }

}
