package lv.tsi.oodb.db.query;

import lv.tsi.oodb.db.orders.*;
import lv.tsi.oodb.odmg.*;
import org.odmg.ODMGException;

import java.util.*;

/**
 * ODMG classes implementation test.
 *
 * @author  Alexey Gulyaev
 * @version 0.0.1 18 December 2000
 */
public class InsertSubOrder_Items {


////////////////////////////////////
//
    private static String DATABASE_NAME = "Buyer";

    public static void main( String[] str ) throws Exception {
        Database db = new Database();
        //  ------------------------------------------------
        // | Opening the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Opening database..." );
            db.open( DATABASE_NAME, Database.OPEN_READ_WRITE );
    	    System.out.println( "ok." );
        } catch (ODMGException e) {
            System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
    	    System.exit(1);
        }
        //  ------------------------------------------------
        // | Binding object to the database
        //  ------------------------------------------------
        Transaction txn = new Transaction( db );
        txn.begin();

        long time = System.currentTimeMillis();

//////////////////////////////////////////////
////// The MAIN PART  ////////////////////////
//////////////////////////////////////////////
        try {

            Order o = new Order();
            o.init( "8321-32423", "WEB" );

              SubOrder s1 = new SubOrder();
              s1.init("8392-3819", "INVENTORY", "21", 0.5F, null, "0x930232", "0x394222");

                Item i1 = new Item();
                i1.init(10, null, 300, 0.4F, "Telefon SIEMENS S45", 300);

                Item i2 = new Item();
                i2.init( 1, null, 200, 0.4F, "Telefon SIEMENS S35", 200);

                Item i3 = new Item();
                i3.init( 2, null, 180, 0.4F, "Telefon SIEMENS S25", 180);

                Item i4 = new Item();
                i4.init( 4, null, 160, 0.4F, "Telefon SIEMENS C35", 160);

              s1.addItem( i1 );
              s1.addItem( i2 );
              s1.addItem( i3 );
              s1.addItem( i4 );

              SubOrder s2 = new SubOrder();
              s2.init("8395-3812", "INVENTORY", "21", 0.43F, null, "0x930232", "0x394222");

                i1 = new Item();
                i1.init( 15, null, 500, 0.4F, "Bosh Washer WFL-2000", 500);

              s2.addItem( i1 );

            o.addSubOrder( s1 );


        } catch (Exception exc) {
            // in case something went wrong, we abort the transaction
            // this is especially important to release all locks
            // then we "rethrow" the exception
            txn.abort();
            throw exc;
        }
//////////////////////////////////////////////
//////////////////////////////////////////////
        txn.commit();
        System.out.println("Query time: " + (System.currentTimeMillis() - time)/1000 + " sec." ); 
        txn.dump();

        db.dump();


        //  ------------------------------------------------
        // | Closing the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Closing database..." );
    	    db.close();
    	    System.out.println( "ok." );
        } catch (ODMGException e) {
    	    System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
        }

	}

}