package lv.tsi.oodb.db.query;

import lv.tsi.oodb.core.Extent;
import lv.tsi.oodb.db.orders.*;
import lv.tsi.oodb.odmg.*;
import org.odmg.ODMGException;

import java.util.*;

/**
 * ODMG classes implementation test.
 *
 * @author  Alexey Gulyaev
 * @version 0.0.1 18 December 2000
 */
public class SelectTotalSubOrderSum {


////////////////////////////////////
//
    private static String DATABASE_NAME = "Buyer2Supplier";

    public static void main( String[] str ) throws Exception {
        Database db = new Database();
        //  ------------------------------------------------
        // | Opening the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Opening database..." );
            db.open( DATABASE_NAME, Database.OPEN_READ_WRITE );
    	    System.out.println( "ok." );
        } catch (ODMGException e) {
            System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
    	    System.exit(1);
        }
        //  ------------------------------------------------
        // | Binding object to the database
        //  ------------------------------------------------
        Transaction txn = new Transaction( db );
        txn.begin();

        long time = System.currentTimeMillis();

//////////////////////////////////////////////
////// The MAIN PART  ////////////////////////
//////////////////////////////////////////////
        try {

            Extent ext = new Extent("lv.tsi.oodb.db.orders.SubOrder");

            float sum = 0;
            while (ext.hasNext())  {
                SubOrder s = (SubOrder)ext.next();
                sum += s.getTotalSum();
            }
            System.out.println( "Total sum:  " + sum + " $");

        } catch (Exception exc) {
            // in case something went wrong, we abort the transaction
            // this is especially important to release all locks
            // then we "rethrow" the exception
            txn.abort();
            throw exc;
        }
//////////////////////////////////////////////
//////////////////////////////////////////////
        txn.commit();
        System.out.println("Query time: " + (System.currentTimeMillis() - time)/1000 + " sec." ); 
        txn.dump();

        db.dump();


        //  ------------------------------------------------
        // | Closing the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Closing database..." );
    	    db.close();
    	    System.out.println( "ok." );
        } catch (ODMGException e) {
    	    System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
        }

	}

}