package lv.tsi.oodb.db.sample;

import lv.tsi.oodb.core.Extent;
import lv.tsi.oodb.core.TransactionManager;
import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.OODBRuntimeException;
import org.odmg.ODMGException;
import org.odmg.ObjectNameNotUniqueException;
import org.odmg.ObjectNameNotFoundException;

import java.util.*;

/**
 * ODMG classes implementation test.
 *
 * @author  Alexey Vasilyev
 * @version 0.0.1 10 November 2000
 */
public class Insert3 {


////////////////////////////////////
//
    private static String OBJECT_NAME = "Test";

	public static void main( String[] str ) throws Exception {
        Database db = new Database();
        //  ------------------------------------------------
        // | Opening the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Opening database..." );
            db.open( "student", Database.OPEN_READ_WRITE );
    	    System.out.println( "ok." );
    	    db.dump();
        } catch (ODMGException e) {
            System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
    	    System.exit(1);
        }
        //  ------------------------------------------------
        // | Binding object to the database
        //  ------------------------------------------------
        Transaction txn = new Transaction( db );
        txn.begin();
        txn.dump();
        //System.out.println( "Transaction start debug: " + txn.toString() );
        //System.out.println( "TransactionMngr start debug: " + TransactionManager.getCurrent().toString() );

//////////////////////////////////////////////
////// The MAIN PART  ////////////////////////
//////////////////////////////////////////////
        try {
            Student s1 = new Student();
            s1.setName("Ivanov");
            Student s2 = new Student();
            s2.setName("Petrov");
            Student s3 = new Student();
            s3.setName("Sidorov");

            Lecturer  p1 = new Lecturer();
            p1.setName("Smirnoff");
            p1.addStudent( s1 );
            p1.addStudent( s2 );
            p1.addStudent( s3 );

            Lecturer  p2 = new Lecturer();
            p2.setName("Sokoloff");
            p2.addStudent( s2 );

            //db.bind( p1, null );    // Also you can use naming and 
            //db.bind( p2, null );    // do db.bind( p1, "Smirnoff" ) instead of null
            db.bind( p1, "Smirnof" );
            //db.bind( p1, "Smirnof" );
            db.bind( p2, "Sokolof" );
        } catch (Exception exc) {
            // in case something went wrong, we abort the transaction
            // this is especially important to release all locks
            // then we "rethrow" the exception
            db.dump();
            txn.dump();

            txn.abort();

            db.dump();
            txn.dump();
            throw exc;
        }
//////////////////////////////////////////////
//////////////////////////////////////////////
        txn.dump();

        db.dump();
        txn.commit();
        db.dump();

        txn = new Transaction( db );
        txn.begin();
        txn.dump();
        //System.out.println( "Transaction start debug: " + txn.toString() );
        //System.out.println( "TransactionMngr start debug: " + TransactionManager.getCurrent().toString() );

//////////////////////////////////////////////
////// The MAIN PART  ////////////////////////
//////////////////////////////////////////////
        try {

            System.out.println( "Start" );
            //Extent myClasses = new Extent(db, "Prepod");
            Extent myClasses = new Extent("lv.tsi.oodb.db.sample.Lecturer");

            while (myClasses.hasNext())  {
                Lecturer p = (Lecturer)myClasses.next();
                Iterator i = p.getStudents().iterator();
                int sum = 0;
                while (i.hasNext())
                    sum += ((Student)i.next()).getMark();
                System.out.println( "Lecturer: " + p + " Sum marks: " + sum );
            }
        } catch (Exception exc) {
            // in case something went wrong, we abort the transaction
            // this is especially important to release all locks
            // then we "rethrow" the exception
            db.dump();
            txn.dump();

            txn.abort();

            db.dump();
            txn.dump();
            throw exc;
        }
//////////////////////////////////////////////
//////////////////////////////////////////////
        txn.dump();

        db.dump();
        txn.commit();
        db.dump();

        lv.tsi.oodb.OODB.getCurrent().dump();
        //System.out.println("Sokol2: " + db.lookup("Sokol2"));
        //  ------------------------------------------------
        // | Closing the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Closing database..." );
    	    db.close();
    	    System.out.println( "ok." );
        } catch (ODMGException e) {
    	    System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
        }

	}

}