package lv.tsi.oodb.db.sample;

import lv.tsi.oodb.core.Extent;
import lv.tsi.oodb.core.TransactionManager;
import lv.tsi.oodb.odmg.*;
import lv.tsi.oodb.core.OODBRuntimeException;
import org.odmg.ODMGException;
import org.odmg.ObjectNameNotUniqueException;
import org.odmg.ObjectNameNotFoundException;

import java.util.*;

/**
 * ODMG classes implementation test.
 *
 * @author  Alexey Vasilyev
 * @version 0.0.1 10 November 2000
 */
public class Select1 {


////////////////////////////////////
//
    private static String OBJECT_NAME = "Test";

    public static void main( String[] str ) throws Exception {
        Database db = new Database();
        //  ------------------------------------------------
        // | Opening the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Opening database..." );
            db.open( "student", Database.OPEN_READ_WRITE );
    	    System.out.println( "ok." );
    	    db.dump();
        } catch (ODMGException e) {
            System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
    	    System.exit(1);
        }
        //  ------------------------------------------------
        // | Testing to the database
        //  ------------------------------------------------
        long time = System.currentTimeMillis();
        Transaction txn = new Transaction( db );
        txn.begin();
        try {
            Lecturer p = (Lecturer)db.lookup("Smirnof");
            System.out.println("Lecturer: " + p );
        } catch (Exception e) {
            txn.abort();
        }
        txn.commit();
        System.out.println("Time: " + (System.currentTimeMillis() - time) ); 

        //lv.tsi.oodb.OODB.getCurrent().dump();
        //  ------------------------------------------------
        // | Closing the database
        //  ------------------------------------------------
        try {
    	    System.out.print( "Closing database..." );
    	    db.close();
    	    System.out.println( "ok." );
        } catch (ODMGException e) {
    	    System.out.println( "error.\nExited." );
    	    System.out.print( e.getMessage() );
        }

	}

}