package lv.tsi.oodb.debug;

import java.sql.*;

/**
 * Database connection pool.
 *
 * @version 0.0.2 23 August 2000
 * @author Alexey Vasilyev
 */
public class DBConnections {

    private static Connection con;
    private static Driver     driver;
    private static int        pool = 1;

    /**
     *
     */
    public DBConnections() {
    }

    /**
     * Initialize connection pool.
     */
    public static void init (String driverName, String url) {
        System.out.println( "Initializing DB connections..." );
        System.out.println( "JDBC driver: '" + driverName + "'" );
        System.out.println( "JDBC url:    '" + url + "'" );
        // REGISTER DRIVER
        try {
            driver = (Driver)Class.forName( driverName ).newInstance();
        } catch (Exception e) {
            System.out.println( e.toString() );
            System.exit(-1);
        }
	    
        // GET CONNECTION
        try {
            con = DriverManager.getConnection( url );
            //con.setAutoCommit( false );
        } catch(Exception e){
            System.out.println( e.toString() );
            System.exit(-1);
        }
        System.out.println( "DB connections initialized ok." );
    }

    /**
     * @return connection fron the pool
     */
    public static synchronized Connection getConnection() {
        return con;
    }

    /**
     * Close all opened conenctions.
     */
    public static void close() {
        try {
            con.close();
        } catch (SQLException e) {
            System.out.println( e.toString() );
        }
    }

}