package lv.tsi.oodb.odmg;

import org.odmg.*;
import java.util.Enumeration;

/**
 * List.
 *
 * This class represents relationship 1:M
 * There can be not-unique values and the list is ordered.
 * Equivalent to ODMG 3.0
 *   LIST <Type>
 *
 * @author Alexey Vasilyev
 * @version 0.0.1 4 November 2000
 */
public class ListOfObject extends java.util.ArrayList implements org.odmg.DList {

    /**
     * Creates a new DList object that contains the contents of this DList object
     * concatenated with the contents of the otherList object.
     *
     * @return new DBag object which is the union of the two sets: the current and the given
     */
    public DList concat( DList otherList ) {
        DList list = (DList)this.clone();
        list.add( otherList );
        return list;
    }

// DCollection

    /**
     * @param predicate   OQL predicate. For example, "student=5".
     */
    public Object selectElement(String predicate) throws QueryInvalidException {
        // Not implemented yet
        throw new NotImplementedException ("OQL not supported");
    }

    public java.util.Iterator select(String predicate) throws QueryInvalidException {
        // Not implemented yet
        throw new NotImplementedException ("OQL not supported");
    }

    public DCollection query(String predicate) throws QueryInvalidException {
        // Not implemented yet
        throw new NotImplementedException ("OQL not supported");
    }

    public boolean existsElement(String predicate) throws QueryInvalidException {
        // Not implemented yet
        throw new NotImplementedException ("OQL not supported");
    }

}